/*
 * Copyright 2024 Luca Fulchir <luca.fulchir@runesauth.com>
 *
 * Licensed under the Apache License, Version 2.0 with LLVM exception (the
 * "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License and of the exception at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *     https://spdx.org/licenses/LLVM-exception.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

//!
//! Example of two package repositories, where one
//! extends ancd changes another

pub mod pkgs;

// FIXME: why?
use ::bok_macro::repo_impl_methods;
use ::bok_macro::repo_impl_pkg_deps;
// Export multiple packages in this module
use ::bok::repository;

///
/// Base repository with some packages
#[::bok::repository(::bok::RepositoryEmpty)]
#[::bok::repo_packages(pkgs::one::One)]
#[derive(::std::default::Default)]
pub struct Pkgs1 {
    r1: i32,
}

#[::bok::repo_impl]
impl Pkgs1 {}

///
/// This repository extends and changes Pkgs1
#[::bok::repository(Pkgs1)]
#[::bok::repo_packages(pkgs::two::Two)]
#[derive(::std::default::Default)]
pub struct Pkgs2 {
    r2: i32,
}

#[::bok::repo_impl]
impl Pkgs2 {}

/*
impl Pkgs2 {
    /// override the package `two` options from the base repostiory (Pkgs1)
    pub fn two(&self) -> Two {
        use ::bok::PkgBuilder;
        let pkg: Box<dyn ::bok::Pkg> = Two::builder()
            .my_attr(42)
            .build()
            .expect("Can't build package Two");

        let two = pkg.as_any().downcast_ref::<Two>().unwrap();
        two.clone()
    }
}

/// This repository extends both Pkgs1 and Pkgs2
#[::bok::repository(Pkgs2)]
#[::bok::repository(Pkgs1)]
#[derive(::std::default::Default)]
pub struct Pkgs3 {}
*/
